import{s as Y,n as B,o as D}from"../chunks/scheduler.f7e1785c.js";import{S as F,i as J,g as o,s as c,u as O,A as G,h as i,f as t,c as u,j as x,v as K,y as b,k as v,o as k,a as n,w as Q,d as V,t as X,x as Z}from"../chunks/index.815a732f.js";import{I as ee}from"../chunks/IconCopyLink.e7937f56.js";function te(j){let s,C,w,P,r,l,y,d,M,g,I="Unit 2. A gentle introduction to audio applications",A,p,N=`Welcome to the second unit of the Hugging Face audio course! Previously, we explored the fundamentals of audio data
and learned how to work with audio datasets using the 🤗 Datasets and 🤗 Transformers libraries. We discussed various
concepts such as sampling rate, amplitude, bit depth, waveform, and spectrograms, and saw how to preprocess data to
prepare it for a pre-trained model.`,T,h,U=`At this point you may be eager to learn about the audio tasks that 🤗 Transformers can handle, and you have all the foundational
knowledge necessary to dive in! Let’s take a look at some of the mind-blowing audio task examples:`,$,f,W=`<li><strong>Audio classification</strong>: easily categorize audio clips into different categories. You can identify whether a recording
is of a barking dog or a meowing cat, or what music genre a song belongs to.</li> <li><strong>Automatic speech recognition</strong>: transform audio clips into text by transcribing them automatically. You can get a text
representation of a recording of someone speaking, like “How are you doing today?“. Rather useful for note taking!</li> <li><strong>Speaker diarization</strong>: Ever wondered who’s speaking in a recording? With 🤗 Transformers, you can identify which speaker
is talking at any given time in an audio clip. Imagine being able to differentiate between “Alice” and “Bob” in a recording
of them having a conversation.</li> <li><strong>Text to speech</strong>: create a narrated version of a text that can be used to produce an audio book, help with accessibility,
or give a voice to an NPC in a game. With 🤗 Transformers, you can easily do that!</li>`,L,m,z=`In this unit, you’ll learn how to use pre-trained models for some of these tasks using the <code>pipeline()</code> function from 🤗 Transformers.
Specifically, we’ll see how the pre-trained models can be used for audio classification, automatic speech recognition and audio generation.
Let’s get started!`,E,_,S;return d=new ee({}),{c(){s=o("meta"),C=c(),w=o("p"),P=c(),r=o("h1"),l=o("a"),y=o("span"),O(d.$$.fragment),M=c(),g=o("span"),g.textContent=I,A=c(),p=o("p"),p.textContent=N,T=c(),h=o("p"),h.textContent=U,$=c(),f=o("ul"),f.innerHTML=W,L=c(),m=o("p"),m.innerHTML=z,E=c(),_=o("p"),this.h()},l(e){const a=G("svelte-1phssyn",document.head);s=i(a,"META",{name:!0,content:!0}),a.forEach(t),C=u(e),w=i(e,"P",{}),x(w).forEach(t),P=u(e),r=i(e,"H1",{class:!0});var H=x(r);l=i(H,"A",{id:!0,class:!0,href:!0});var q=x(l);y=i(q,"SPAN",{});var R=x(y);K(d.$$.fragment,R),R.forEach(t),q.forEach(t),M=u(H),g=i(H,"SPAN",{"data-svelte-h":!0}),b(g)!=="svelte-17eawhj"&&(g.textContent=I),H.forEach(t),A=u(e),p=i(e,"P",{"data-svelte-h":!0}),b(p)!=="svelte-vj6e2"&&(p.textContent=N),T=u(e),h=i(e,"P",{"data-svelte-h":!0}),b(h)!=="svelte-qbuu6d"&&(h.textContent=U),$=u(e),f=i(e,"UL",{"data-svelte-h":!0}),b(f)!=="svelte-1bxzjf0"&&(f.innerHTML=W),L=u(e),m=i(e,"P",{"data-svelte-h":!0}),b(m)!=="svelte-r8m8hy"&&(m.innerHTML=z),E=u(e),_=i(e,"P",{}),x(_).forEach(t),this.h()},h(){v(s,"name","hf:doc:metadata"),v(s,"content",JSON.stringify(ae)),v(l,"id","unit-2-a-gentle-introduction-to-audio-applications"),v(l,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),v(l,"href","#unit-2-a-gentle-introduction-to-audio-applications"),v(r,"class","relative group")},m(e,a){k(document.head,s),n(e,C,a),n(e,w,a),n(e,P,a),n(e,r,a),k(r,l),k(l,y),Q(d,y,null),k(r,M),k(r,g),n(e,A,a),n(e,p,a),n(e,T,a),n(e,h,a),n(e,$,a),n(e,f,a),n(e,L,a),n(e,m,a),n(e,E,a),n(e,_,a),S=!0},p:B,i(e){S||(V(d.$$.fragment,e),S=!0)},o(e){X(d.$$.fragment,e),S=!1},d(e){e&&(t(C),t(w),t(P),t(r),t(A),t(p),t(T),t(h),t($),t(f),t(L),t(m),t(E),t(_)),t(s),Z(d)}}}const ae={local:"unit-2-a-gentle-introduction-to-audio-applications",title:"Unit 2. A gentle introduction to audio applications"};function ne(j){return D(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class re extends F{constructor(s){super(),J(this,s,ne,te,Y,{})}}export{re as component};
