import{s as le,f as re,n as ue,o as he}from"../chunks/scheduler.f7e1785c.js";import{S as ce,i as de,g as i,s,u as pe,A as fe,h as o,f as t,c as l,j as A,v as me,y as u,k as h,o as H,a,w as ve,d as we,t as ge,x as ye}from"../chunks/index.815a732f.js";import{I as xe}from"../chunks/IconCopyLink.e7937f56.js";function _e(G){let c,L,P,M,d,p,T,m,F,C,J="What you'll learn and what you'll build",$,v,O="In this section, we’ll take a look at how Transformers can be used to convert spoken speech into text, a task known <em>speech recognition</em>.",E,f,V='<img src="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/asr_diagram.png" alt="Diagram of speech to text"/>',I,w,K=`Speech recognition, also known as automatic speech recognition (ASR) or speech-to-text (STT), is one of the most popular
and exciting spoken language processing tasks. It’s used in a wide range of applications, including dictation, voice assistants,
video captioning and meeting transcriptions.`,R,g,Q=`You’ve probably made use of a speech recognition system many times before without realising! Consider the digital
assistant in your smartphone device (Siri, Google Assistant, Alexa). When you use these assistants, the first thing that
they do is transcribe your spoken speech to written text, ready to be used for any downstream tasks (such as finding you
the weather 🌤️).`,j,y,X=`Have a play with the speech recognition demo below. You can either record yourself using your microphone, or drag and
drop an audio sample for transcription:`,q,r,Z="",ee,z,x,te=`Speech recognition is a challenging task as it requires joint knowledge of audio and text. The input audio might have
lots of background noise and be spoken by speakers with different accents, making it difficult to pick out the spoken
speech. The written text might have characters which don’t have an acoustic sound, such as punctuation, which are difficult
to infer from audio alone. These are all hurdles we have to tackle when building effective speech recognition systems!`,N,_,ne=`Now that we’ve defined our task, we can begin looking into speech recognition in more detail. By the end of this Unit,
you’ll have a good fundamental understanding of the different pre-trained speech recognition models available and how to
use them with the 🤗 Transformers library. You’ll also know the procedure for fine-tuning an ASR model on a domain or
language of choice, enabling you to build a performant system for whatever task you encounter. You’ll be able to showcase
your model to your friends and family by building a live demo, one that takes any spoken speech and converts it to text!`,Y,k,ae="Specifically, we’ll cover:",U,b,ie='<li><a href="asr_models">Pre-trained models for speech recognition</a></li> <li><a href="choosing_dataset">Choosing a dataset</a></li> <li><a href="evaluation">Evaluation and metrics for speech recognition</a></li> <li><a href="fine-tuning">How to fine-tune an ASR system with the Trainer API</a></li> <li><a href="demo">Building a demo</a></li> <li><a href="hands_on">Hands-on exercise</a></li>',W,S,B;return m=new xe({}),{c(){c=i("meta"),L=s(),P=i("p"),M=s(),d=i("h1"),p=i("a"),T=i("span"),pe(m.$$.fragment),F=s(),C=i("span"),C.textContent=J,$=s(),v=i("p"),v.innerHTML=O,E=s(),f=i("div"),f.innerHTML=V,I=s(),w=i("p"),w.textContent=K,R=s(),g=i("p"),g.textContent=Q,j=s(),y=i("p"),y.textContent=X,q=s(),r=i("iframe"),r.innerHTML=Z,z=s(),x=i("p"),x.textContent=te,N=s(),_=i("p"),_.textContent=ne,Y=s(),k=i("p"),k.textContent=ae,U=s(),b=i("ul"),b.innerHTML=ie,W=s(),S=i("p"),this.h()},l(e){const n=fe("svelte-1phssyn",document.head);c=o(n,"META",{name:!0,content:!0}),n.forEach(t),L=l(e),P=o(e,"P",{}),A(P).forEach(t),M=l(e),d=o(e,"H1",{class:!0});var D=A(d);p=o(D,"A",{id:!0,class:!0,href:!0});var oe=A(p);T=o(oe,"SPAN",{});var se=A(T);me(m.$$.fragment,se),se.forEach(t),oe.forEach(t),F=l(D),C=o(D,"SPAN",{"data-svelte-h":!0}),u(C)!=="svelte-mzaipk"&&(C.textContent=J),D.forEach(t),$=l(e),v=o(e,"P",{"data-svelte-h":!0}),u(v)!=="svelte-gm4czj"&&(v.innerHTML=O),E=l(e),f=o(e,"DIV",{class:!0,"data-svelte-h":!0}),u(f)!=="svelte-gouu61"&&(f.innerHTML=V),I=l(e),w=o(e,"P",{"data-svelte-h":!0}),u(w)!=="svelte-xmgt0n"&&(w.textContent=K),R=l(e),g=o(e,"P",{"data-svelte-h":!0}),u(g)!=="svelte-e3ezub"&&(g.textContent=Q),j=l(e),y=o(e,"P",{"data-svelte-h":!0}),u(y)!=="svelte-28ph8z"&&(y.textContent=X),q=l(e),r=o(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0,"data-svelte-h":!0}),u(r)!=="svelte-aw0ubw"&&(r.innerHTML=Z),z=l(e),x=o(e,"P",{"data-svelte-h":!0}),u(x)!=="svelte-9savi7"&&(x.textContent=te),N=l(e),_=o(e,"P",{"data-svelte-h":!0}),u(_)!=="svelte-1klaps2"&&(_.textContent=ne),Y=l(e),k=o(e,"P",{"data-svelte-h":!0}),u(k)!=="svelte-96ho0"&&(k.textContent=ae),U=l(e),b=o(e,"UL",{"data-svelte-h":!0}),u(b)!=="svelte-t4qu3r"&&(b.innerHTML=ie),W=l(e),S=o(e,"P",{}),A(S).forEach(t),this.h()},h(){h(c,"name","hf:doc:metadata"),h(c,"content",JSON.stringify(ke)),h(p,"id","what-youll-learn-and-what-youll-build"),h(p,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(p,"href","#what-youll-learn-and-what-youll-build"),h(d,"class","relative group"),h(f,"class","flex justify-center"),re(r.src,ee="https://course-demos-whisper-small.hf.space")||h(r,"src",ee),h(r,"frameborder","0"),h(r,"width","850"),h(r,"height","450")},m(e,n){H(document.head,c),a(e,L,n),a(e,P,n),a(e,M,n),a(e,d,n),H(d,p),H(p,T),ve(m,T,null),H(d,F),H(d,C),a(e,$,n),a(e,v,n),a(e,E,n),a(e,f,n),a(e,I,n),a(e,w,n),a(e,R,n),a(e,g,n),a(e,j,n),a(e,y,n),a(e,q,n),a(e,r,n),a(e,z,n),a(e,x,n),a(e,N,n),a(e,_,n),a(e,Y,n),a(e,k,n),a(e,U,n),a(e,b,n),a(e,W,n),a(e,S,n),B=!0},p:ue,i(e){B||(we(m.$$.fragment,e),B=!0)},o(e){ge(m.$$.fragment,e),B=!1},d(e){e&&(t(L),t(P),t(M),t(d),t($),t(v),t(E),t(f),t(I),t(w),t(R),t(g),t(j),t(y),t(q),t(r),t(z),t(x),t(N),t(_),t(Y),t(k),t(U),t(b),t(W),t(S)),t(c),ye(m)}}}const ke={local:"what-youll-learn-and-what-youll-build",title:"What you'll learn and what you'll build"};function be(G){return he(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Se extends ce{constructor(c){super(),de(this,c,be,_e,le,{})}}export{Se as component};
