import{s as wr,o as _r}from"../chunks/scheduler.f7e1785c.js";import{S as Cr,i as qr,g as s,s as a,u as p,A as br,h as o,f as t,c as i,j as d,v as f,y as m,k as l,o as u,a as r,w as h,d as v,t as g,x,m as Tr,n as yr}from"../chunks/index.815a732f.js";import{T as Lr}from"../chunks/Tip.1258ac78.js";import{I as $}from"../chunks/IconCopyLink.e7937f56.js";function Hr(nt){let c;return{c(){c=Tr("💡 Si vous prenez une forme d'onde existante et appliquez la transformée de Fourier à court terme (TFCT), il est possible d'effectuer l'opération inverse pour obtenir à nouveau la forme d'onde d'origine. Cela fonctionne parce que le spectrogramme créé par la TFCT contient à la fois des informations d'amplitude et de phase, et les deux sont nécessaires pour reconstruire la forme d'onde. Cependant, les modèles audio qui génèrent leur sortie sous forme de spectrogramme ne prédisent généralement que les informations d'amplitude, pas la phase. Pour transformer un tel spectrogramme en une forme d'onde, nous devons en quelque sorte estimer l'information de phase. C'est ce que fait un vocodeur.")},l(w){c=yr(w,"💡 Si vous prenez une forme d'onde existante et appliquez la transformée de Fourier à court terme (TFCT), il est possible d'effectuer l'opération inverse pour obtenir à nouveau la forme d'onde d'origine. Cela fonctionne parce que le spectrogramme créé par la TFCT contient à la fois des informations d'amplitude et de phase, et les deux sont nécessaires pour reconstruire la forme d'onde. Cependant, les modèles audio qui génèrent leur sortie sous forme de spectrogramme ne prédisent généralement que les informations d'amplitude, pas la phase. Pour transformer un tel spectrogramme en une forme d'onde, nous devons en quelque sorte estimer l'information de phase. C'est ce que fait un vocodeur.")},m(w,X){r(w,c,X)},d(w){w&&t(c)}}}function Pr(nt){let c,w,X,rt,_,S,Fe,Y,en,Ee,pn="Unité 3 : Architectures de transformers pour l'audio",st,Z,fn='Dans ce cours, nous examinons principalement les <em>transformers</em> et comment ils peuvent être appliqués aux tâches audio. Bien que vous n’ayez pas besoin de connaître les détails internes de ces modèles, il est utile de comprendre les principaux concepts qui les font fonctionner. Nous faisons donc ici un rappel rapide. Pour une plongée profonde dans les <em>transformers</em>, consultez notre <a href="https://huggingface.co/learn/nlp-course/fr/chapter1/1" rel="nofollow">cours de NLP</a>.',ot,C,A,We,ee,tn,Me,hn="Comment fonctionne un transformer ?",lt,te,vn="Le <em>transformer</em> original a été conçu pour traduire du texte écrit d’une langue à une autre. Son architecture ressemble à ceci :",at,N,gn='<img src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/transformers.svg" alt="Original transformer architecture"/>',it,ne,xn="À gauche se trouve l’<strong>encodeur</strong> et à droite le <strong>décodeur</strong>.",ut,re,$n=`<li>L’encodeur reçoit une entrée, dans ce cas une séquence de <em>tokens</em> de texte, et construit une représentation de celle-ci (ses caractéristiques). Cette partie du modèle est entraînée pour acquérir une compréhension à partir de l’entrée.</li> <li>Le décodeur utilise la représentation de l’encodeur (les caractéristiques) ainsi que d’autres entrées (les <em>tokens</em> prédits précédemment) pour générer une séquence cible. Cette partie du modèle est entraînée pour générer des extrants. Dans la conception originale, la séquence de sortie se composait de <em>tokens</em> de texte.
Il existe également des modèles basés sur des <em>transformers</em> n’utilisant que la partie encodeur (bon pour les tâches qui nécessitent une compréhension de l’entrée, comme la classification), ou uniquement la partie décodeur (bon pour les tâches telles que la génération de texte). Un exemple de modèle d’encodeur seul est BERT ; un exemple de modèle de décodeur seul est GPT2.
Une caractéristique clé des <em>transformers</em> est qu’ils sont construits avec des couches spéciales appelées <strong>couches d’attention</strong>. Ces couches indiquent au modèle d’accorder une attention particulière à certains éléments de la séquence d’entrée et d’en ignorer d’autres lors du calcul des représentations d’entités.</li>`,dt,q,j,Be,se,nn,Se,wn="Utilisation de *transformers* pour l'audio",mt,oe,_n="Les modèles audio que nous aborderons dans ce cours ont généralement un <em>transformer</em> standard comme indiqué ci-dessus, mais avec une légère modification du côté de l’entrée ou de la sortie pour gérer des données audio au lieu de texte. Puisque tous ces modèles sont des <em>transformers</em> dans l’âme, ils ont pour la plupart une architecture commune et les principales différences sont dans la façon dont ils sont entraînés et utilisés.",ct,z,Cn='<img src="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/transformers_blocks.png" alt="The transformer with audio input and output"/>',pt,le,qn="Pour les tâches audio, les séquences d’entrée et/ou de sortie sont de l’audio au lieu de texte :",ft,ae,bn="<li>Reconnaissance automatique de la parole (ASR pour <em>Automatic speech recognition</em>) : l’entrée est la parole, la sortie est du texte.</li> <li>Synthèse vocale (TTS pour <em>Text-to-speech</em>) : l’entrée est du texte, la sortie est de la parole.</li> <li>Classification audio : l’entrée est de l’audio, la sortie est une probabilité de classe (une pour chaque élément de la séquence ou une probabilité de classe unique pour la séquence entière).</li> <li>Conversion vocale ou amélioration de la parole : l’entrée et la sortie sont de l’audio.</li>",ht,ie,Tn="Il existe différentes façons de gérer l’audio afin qu’il puisse être utilisé via un <em>transformer</em>. La principale considération est de savoir s’il faut utiliser l’audio dans sa forme brute (comme une forme d’onde) ou le traiter comme un spectrogramme à la place.",vt,b,U,Oe,ue,rn,Ae,yn="Entrées du modèle",gt,de,Ln="L’entrée d’un modèle audio peut être du texte ou du son. L’objectif est de convertir cette entrée en un enchâssement pouvant être traité par le <em>transformer</em>.",xt,T,I,Ge,me,sn,Ne,Hn="Entrée textuelle",$t,ce,Pn="Un modèle de synthèse vocale prend du texte comme entrée. Cela fonctionne comme le <em>transformer</em> d’origine en NLP : le texte d’entrée est d’abord tokenisé, ce qui donne une séquence de <em>tokens</em> de texte. Cette séquence est envoyée via une couche d’enchâssement d’entrée pour convertir les <em>tokens</em> en vecteurs de 512 dimensions. Ces enchâssements sont ensuite transmis dans l’encodeur du <em>transformer</em>.",wt,y,D,Je,pe,on,je,kn="Entrée sous forme de forme d'onde",_t,fe,En=`Un modèle de reconnaissance de la parole automatique prend l’audio comme entrée. Pour pouvoir utiliser un <em>transformer</em> pour l’ASR, nous devons d’abord convertir l’audio en une séquence d’enchâssements d’une manière ou d’une autre.
Des modèles tels que <strong><a href="https://arxiv.org/abs/2006.11477" rel="nofollow">Wav2Vec2</a></strong> et <strong><a href="https://arxiv.org/abs/2106.07447" rel="nofollow">HuBERT</a></strong> utilisent la forme d’onde audio directement comme entrée du modèle. Comme vous l’avez vu dans [le chapitre sur les données audio (../chapter1/introduction), une forme d’onde est une séquence unidimensionnelle de nombres à virgule flottante, où chaque nombre représente l’amplitude échantillonnée à un moment donné. Cette forme d’onde brute est d’abord normalisée à la moyenne nulle et à la variance unitaire, ce qui permet de normaliser les échantillons audio sur différents volumes (amplitudes).`,Ct,R,Mn='<img src="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/wav2vec2-input.png" alt="Wav2Vec2 uses a CNN to create embeddings from the input waveform"/>',qt,he,Sn="Après la normalisation, la séquence d’échantillons audio est transformée en un enchâssement à l’aide d’un petit réseau neuronal convolutionnel, connu sous le nom d’encodeur de caractéristiques. Chacune des couches convolutives de ce réseau traite la séquence d’entrée, sous-échantillonnant l’audio pour réduire la longueur de la séquence, jusqu’à ce que la couche convolutive finale produise un vecteur à 512 dimensions avec l’enchâssement pour chaque 25 ms d’audio. Une fois que la séquence d’entrée a été transformée en une séquence de tels enchâssements, le <em>transformer</em> traitera les données comme d’habitude.",bt,L,V,Ke,ve,ln,ze,An="Entrée sous forme de spectrogramme",Tt,ge,Nn=`Un inconvénient de l’utilisation de la forme d’onde brute comme entrée est qu’elles ont tendance à avoir de longues longueurs de séquence. Par exemple, trente secondes d’audio à une fréquence d’échantillonnage de 16 kHz donnent une entrée de longueur <code>30 * 16000 = 480000</code>. Des longueurs de séquence plus longues nécessitent plus de calculs dans le <em>transformer</em> et donc une utilisation plus élevée de la mémoire.
Pour cette raison, les formes d’onde audio brutes ne sont généralement pas la forme la plus efficace de représenter une entrée audio. En utilisant un spectrogramme, nous obtenons la même quantité d’informations, mais sous une forme plus comprimée.`,yt,F,jn='<img src="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/whisper-input.png" alt="Whisper uses a CNN to create embeddings from the input spectrogram"/>',Lt,xe,zn='Des modèles tels que <strong><a href="https://arxiv.org/abs/2212.04356" rel="nofollow">Whisper</a></strong> convertissent d’abord la forme d’onde en un spectrogramme log-mel. Whisper divise toujours l’audio en segments de 30 secondes, et le spectrogramme log-mel pour chaque segment a la forme <code>(80, 3000)</code> où 80 est le nombre de bacs mel et 3000 est la longueur de la séquence. En convertissant en spectrogramme log-mel, nous avons réduit la quantité de données d’entrée, mais plus important encore, il s’agit d’une séquence beaucoup plus courte que la forme d’onde brute. Le spectrogramme log-mel est ensuite traité par un petit réseau convolutif en une séquence d’enchâssements, allant ensuite dans le <em>transformer</em> comme d’habitude.',Ht,$e,Un="Dans les deux cas, l’entrée de la forme d’onde et du spectrogramme, il y a un petit réseau devant le <em>transformer</em> convertissant l’entrée en enchâssement, puis le <em>transformer</em>prend le relais pour faire son travail.",Pt,H,W,Qe,we,an,Ue,In="Sorties du modèle",kt,_e,Dn="L’architecture du <em>transformer</em> génère une séquence de vecteurs à états cachés, également appelés enchâssement de sortie. Notre objectif est de transformer ces vecteurs en sortie textuelle ou audio.",Et,P,B,Xe,Ce,un,Ie,Rn="Sortie textuelle",Mt,qe,Vn="L’objectif d’un modèle d’ASR est de prédire une séquence de <em>tokens</em> de texte. Cela se fait en ajoutant une tête de modélisation du langage (généralement une seule couche linéaire) suivie d’une softmax au-dessus de la sortie du <em>transformer</em>. On alors prédit les probabilités sur les <em>tokens</em> de texte dans le vocabulaire.",St,k,O,Ye,be,dn,De,Fn="Sortie sous forme de spectrogramme",At,Te,Wn=`Pour les modèles qui génèrent de l’audio, tels qu’un modèle de synthèse vocale, nous devons ajouter des couches pouvant produire une séquence audio. Il est très courant de générer un spectrogramme, puis d’utiliser un réseau neuronal supplémentaire, connu sous le nom de vocodeur, pour transformer ce spectrogramme en une forme d’onde.
Par exemple dans le modèle <strong><a href="https://arxiv.org/abs/2110.07205" rel="nofollow">SpeechT5</a></strong> la sortie du <em>transformer</em> est une séquence de vecteurs à 768 éléments. Une couche linéaire projette cette séquence dans un spectrogramme log-mel. Un post-réseau, composé de couches linéaires et convolutives supplémentaires, affine le spectrogramme en réduisant le bruit. Le vocodeur crée alors la forme d’onde audio finale.`,Nt,G,Bn='<img src="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/speecht5.png" alt="SpeechT5 outputs a spectrogram and uses a vocoder to create the waveform"/>',jt,J,zt,E,K,Ze,ye,mn,Re,On="Sortie sous forme de forme d'onde",Ut,Le,Gn="Il est également possible pour les modèles de produire directement une forme d’onde au lieu d’un spectrogramme comme étape intermédiaire, mais nous n’avons actuellement aucun modèle dans 🤗 <em>Transformers</em> qui le fait.",It,M,Q,et,He,cn,Ve,Jn="Conclusion",Dt,Pe,Kn=`En résumé: la plupart des <em>transformers</em> audio se ressemblent plus que différents. Ils sont tous construits sur la même architecture et les mêmes couches d’attention, bien que certains modèles n’utilisent que la partie encodeur du <em>transformer</em> tandis que d’autres utilisent à la fois l’encodeur et le décodeur.
Vous avez également vu comment obtenir des données audio dans et hors des <em>transformers</em>. Pour effectuer les différentes tâches audio d’ASR, TTS, etc., nous pouvons simplement échanger les couches qui prétraitent les entrées en enchâssements, et échanger les couches qui post-traitent les enchâssements prédites en sorties, tandis que le <em>backbone</em> du <em>transformer</em> reste le même.
Examinons  dans les suite différentes façons dont ces modèles peuvent être entraînés à effectuer une reconnaissance vocale automatique.`,Rt,tt,Vt;return Y=new $({}),ee=new $({}),se=new $({}),ue=new $({}),me=new $({}),pe=new $({}),ve=new $({}),we=new $({}),Ce=new $({}),be=new $({}),J=new Lr({props:{$$slots:{default:[Hr]},$$scope:{ctx:nt}}}),ye=new $({}),He=new $({}),{c(){c=s("meta"),w=a(),X=s("p"),rt=a(),_=s("h1"),S=s("a"),Fe=s("span"),p(Y.$$.fragment),en=a(),Ee=s("span"),Ee.textContent=pn,st=a(),Z=s("p"),Z.innerHTML=fn,ot=a(),C=s("h2"),A=s("a"),We=s("span"),p(ee.$$.fragment),tn=a(),Me=s("span"),Me.textContent=hn,lt=a(),te=s("p"),te.innerHTML=vn,at=a(),N=s("div"),N.innerHTML=gn,it=a(),ne=s("p"),ne.innerHTML=xn,ut=a(),re=s("ul"),re.innerHTML=$n,dt=a(),q=s("h2"),j=s("a"),Be=s("span"),p(se.$$.fragment),nn=a(),Se=s("span"),Se.textContent=wn,mt=a(),oe=s("p"),oe.innerHTML=_n,ct=a(),z=s("div"),z.innerHTML=Cn,pt=a(),le=s("p"),le.textContent=qn,ft=a(),ae=s("ul"),ae.innerHTML=bn,ht=a(),ie=s("p"),ie.innerHTML=Tn,vt=a(),b=s("h2"),U=s("a"),Oe=s("span"),p(ue.$$.fragment),rn=a(),Ae=s("span"),Ae.textContent=yn,gt=a(),de=s("p"),de.innerHTML=Ln,xt=a(),T=s("h3"),I=s("a"),Ge=s("span"),p(me.$$.fragment),sn=a(),Ne=s("span"),Ne.textContent=Hn,$t=a(),ce=s("p"),ce.innerHTML=Pn,wt=a(),y=s("h3"),D=s("a"),Je=s("span"),p(pe.$$.fragment),on=a(),je=s("span"),je.textContent=kn,_t=a(),fe=s("p"),fe.innerHTML=En,Ct=a(),R=s("div"),R.innerHTML=Mn,qt=a(),he=s("p"),he.innerHTML=Sn,bt=a(),L=s("h3"),V=s("a"),Ke=s("span"),p(ve.$$.fragment),ln=a(),ze=s("span"),ze.textContent=An,Tt=a(),ge=s("p"),ge.innerHTML=Nn,yt=a(),F=s("div"),F.innerHTML=jn,Lt=a(),xe=s("p"),xe.innerHTML=zn,Ht=a(),$e=s("p"),$e.innerHTML=Un,Pt=a(),H=s("h2"),W=s("a"),Qe=s("span"),p(we.$$.fragment),an=a(),Ue=s("span"),Ue.textContent=In,kt=a(),_e=s("p"),_e.innerHTML=Dn,Et=a(),P=s("h3"),B=s("a"),Xe=s("span"),p(Ce.$$.fragment),un=a(),Ie=s("span"),Ie.textContent=Rn,Mt=a(),qe=s("p"),qe.innerHTML=Vn,St=a(),k=s("h3"),O=s("a"),Ye=s("span"),p(be.$$.fragment),dn=a(),De=s("span"),De.textContent=Fn,At=a(),Te=s("p"),Te.innerHTML=Wn,Nt=a(),G=s("div"),G.innerHTML=Bn,jt=a(),p(J.$$.fragment),zt=a(),E=s("h3"),K=s("a"),Ze=s("span"),p(ye.$$.fragment),mn=a(),Re=s("span"),Re.textContent=On,Ut=a(),Le=s("p"),Le.innerHTML=Gn,It=a(),M=s("h2"),Q=s("a"),et=s("span"),p(He.$$.fragment),cn=a(),Ve=s("span"),Ve.textContent=Jn,Dt=a(),Pe=s("p"),Pe.innerHTML=Kn,Rt=a(),tt=s("p"),this.h()},l(e){const n=br("svelte-1phssyn",document.head);c=o(n,"META",{name:!0,content:!0}),n.forEach(t),w=i(e),X=o(e,"P",{}),d(X).forEach(t),rt=i(e),_=o(e,"H1",{class:!0});var ke=d(_);S=o(ke,"A",{id:!0,class:!0,href:!0});var Qn=d(S);Fe=o(Qn,"SPAN",{});var Xn=d(Fe);f(Y.$$.fragment,Xn),Xn.forEach(t),Qn.forEach(t),en=i(ke),Ee=o(ke,"SPAN",{"data-svelte-h":!0}),m(Ee)!=="svelte-aw1uz3"&&(Ee.textContent=pn),ke.forEach(t),st=i(e),Z=o(e,"P",{"data-svelte-h":!0}),m(Z)!=="svelte-hjh2e3"&&(Z.innerHTML=fn),ot=i(e),C=o(e,"H2",{class:!0});var Ft=d(C);A=o(Ft,"A",{id:!0,class:!0,href:!0});var Yn=d(A);We=o(Yn,"SPAN",{});var Zn=d(We);f(ee.$$.fragment,Zn),Zn.forEach(t),Yn.forEach(t),tn=i(Ft),Me=o(Ft,"SPAN",{"data-svelte-h":!0}),m(Me)!=="svelte-1p0yu4i"&&(Me.textContent=hn),Ft.forEach(t),lt=i(e),te=o(e,"P",{"data-svelte-h":!0}),m(te)!=="svelte-1qzgufu"&&(te.innerHTML=vn),at=i(e),N=o(e,"DIV",{class:!0,"data-svelte-h":!0}),m(N)!=="svelte-4s71rk"&&(N.innerHTML=gn),it=i(e),ne=o(e,"P",{"data-svelte-h":!0}),m(ne)!=="svelte-1wbffyo"&&(ne.innerHTML=xn),ut=i(e),re=o(e,"UL",{"data-svelte-h":!0}),m(re)!=="svelte-1ck9bi5"&&(re.innerHTML=$n),dt=i(e),q=o(e,"H2",{class:!0});var Wt=d(q);j=o(Wt,"A",{id:!0,class:!0,href:!0});var er=d(j);Be=o(er,"SPAN",{});var tr=d(Be);f(se.$$.fragment,tr),tr.forEach(t),er.forEach(t),nn=i(Wt),Se=o(Wt,"SPAN",{"data-svelte-h":!0}),m(Se)!=="svelte-1gv2nrc"&&(Se.textContent=wn),Wt.forEach(t),mt=i(e),oe=o(e,"P",{"data-svelte-h":!0}),m(oe)!=="svelte-mifguu"&&(oe.innerHTML=_n),ct=i(e),z=o(e,"DIV",{class:!0,"data-svelte-h":!0}),m(z)!=="svelte-nwa8hg"&&(z.innerHTML=Cn),pt=i(e),le=o(e,"P",{"data-svelte-h":!0}),m(le)!=="svelte-1k5s6bc"&&(le.textContent=qn),ft=i(e),ae=o(e,"UL",{"data-svelte-h":!0}),m(ae)!=="svelte-1f3rz1h"&&(ae.innerHTML=bn),ht=i(e),ie=o(e,"P",{"data-svelte-h":!0}),m(ie)!=="svelte-vu2mlx"&&(ie.innerHTML=Tn),vt=i(e),b=o(e,"H2",{class:!0});var Bt=d(b);U=o(Bt,"A",{id:!0,class:!0,href:!0});var nr=d(U);Oe=o(nr,"SPAN",{});var rr=d(Oe);f(ue.$$.fragment,rr),rr.forEach(t),nr.forEach(t),rn=i(Bt),Ae=o(Bt,"SPAN",{"data-svelte-h":!0}),m(Ae)!=="svelte-1pdc841"&&(Ae.textContent=yn),Bt.forEach(t),gt=i(e),de=o(e,"P",{"data-svelte-h":!0}),m(de)!=="svelte-1emaony"&&(de.innerHTML=Ln),xt=i(e),T=o(e,"H3",{class:!0});var Ot=d(T);I=o(Ot,"A",{id:!0,class:!0,href:!0});var sr=d(I);Ge=o(sr,"SPAN",{});var or=d(Ge);f(me.$$.fragment,or),or.forEach(t),sr.forEach(t),sn=i(Ot),Ne=o(Ot,"SPAN",{"data-svelte-h":!0}),m(Ne)!=="svelte-1pl4zvs"&&(Ne.textContent=Hn),Ot.forEach(t),$t=i(e),ce=o(e,"P",{"data-svelte-h":!0}),m(ce)!=="svelte-137ywy8"&&(ce.innerHTML=Pn),wt=i(e),y=o(e,"H3",{class:!0});var Gt=d(y);D=o(Gt,"A",{id:!0,class:!0,href:!0});var lr=d(D);Je=o(lr,"SPAN",{});var ar=d(Je);f(pe.$$.fragment,ar),ar.forEach(t),lr.forEach(t),on=i(Gt),je=o(Gt,"SPAN",{"data-svelte-h":!0}),m(je)!=="svelte-m1hmiw"&&(je.textContent=kn),Gt.forEach(t),_t=i(e),fe=o(e,"P",{"data-svelte-h":!0}),m(fe)!=="svelte-1d18oho"&&(fe.innerHTML=En),Ct=i(e),R=o(e,"DIV",{class:!0,"data-svelte-h":!0}),m(R)!=="svelte-gtur9r"&&(R.innerHTML=Mn),qt=i(e),he=o(e,"P",{"data-svelte-h":!0}),m(he)!=="svelte-1g9ou8x"&&(he.innerHTML=Sn),bt=i(e),L=o(e,"H3",{class:!0});var Jt=d(L);V=o(Jt,"A",{id:!0,class:!0,href:!0});var ir=d(V);Ke=o(ir,"SPAN",{});var ur=d(Ke);f(ve.$$.fragment,ur),ur.forEach(t),ir.forEach(t),ln=i(Jt),ze=o(Jt,"SPAN",{"data-svelte-h":!0}),m(ze)!=="svelte-eo7njr"&&(ze.textContent=An),Jt.forEach(t),Tt=i(e),ge=o(e,"P",{"data-svelte-h":!0}),m(ge)!=="svelte-nciwcl"&&(ge.innerHTML=Nn),yt=i(e),F=o(e,"DIV",{class:!0,"data-svelte-h":!0}),m(F)!=="svelte-byhcj1"&&(F.innerHTML=jn),Lt=i(e),xe=o(e,"P",{"data-svelte-h":!0}),m(xe)!=="svelte-1dwybjp"&&(xe.innerHTML=zn),Ht=i(e),$e=o(e,"P",{"data-svelte-h":!0}),m($e)!=="svelte-ky1v83"&&($e.innerHTML=Un),Pt=i(e),H=o(e,"H2",{class:!0});var Kt=d(H);W=o(Kt,"A",{id:!0,class:!0,href:!0});var dr=d(W);Qe=o(dr,"SPAN",{});var mr=d(Qe);f(we.$$.fragment,mr),mr.forEach(t),dr.forEach(t),an=i(Kt),Ue=o(Kt,"SPAN",{"data-svelte-h":!0}),m(Ue)!=="svelte-1zbt82"&&(Ue.textContent=In),Kt.forEach(t),kt=i(e),_e=o(e,"P",{"data-svelte-h":!0}),m(_e)!=="svelte-uzv2d6"&&(_e.innerHTML=Dn),Et=i(e),P=o(e,"H3",{class:!0});var Qt=d(P);B=o(Qt,"A",{id:!0,class:!0,href:!0});var cr=d(B);Xe=o(cr,"SPAN",{});var pr=d(Xe);f(Ce.$$.fragment,pr),pr.forEach(t),cr.forEach(t),un=i(Qt),Ie=o(Qt,"SPAN",{"data-svelte-h":!0}),m(Ie)!=="svelte-ggnfhf"&&(Ie.textContent=Rn),Qt.forEach(t),Mt=i(e),qe=o(e,"P",{"data-svelte-h":!0}),m(qe)!=="svelte-1kaiegy"&&(qe.innerHTML=Vn),St=i(e),k=o(e,"H3",{class:!0});var Xt=d(k);O=o(Xt,"A",{id:!0,class:!0,href:!0});var fr=d(O);Ye=o(fr,"SPAN",{});var hr=d(Ye);f(be.$$.fragment,hr),hr.forEach(t),fr.forEach(t),dn=i(Xt),De=o(Xt,"SPAN",{"data-svelte-h":!0}),m(De)!=="svelte-npust8"&&(De.textContent=Fn),Xt.forEach(t),At=i(e),Te=o(e,"P",{"data-svelte-h":!0}),m(Te)!=="svelte-134yejw"&&(Te.innerHTML=Wn),Nt=i(e),G=o(e,"DIV",{class:!0,"data-svelte-h":!0}),m(G)!=="svelte-24c3yo"&&(G.innerHTML=Bn),jt=i(e),f(J.$$.fragment,e),zt=i(e),E=o(e,"H3",{class:!0});var Yt=d(E);K=o(Yt,"A",{id:!0,class:!0,href:!0});var vr=d(K);Ze=o(vr,"SPAN",{});var gr=d(Ze);f(ye.$$.fragment,gr),gr.forEach(t),vr.forEach(t),mn=i(Yt),Re=o(Yt,"SPAN",{"data-svelte-h":!0}),m(Re)!=="svelte-18iyt37"&&(Re.textContent=On),Yt.forEach(t),Ut=i(e),Le=o(e,"P",{"data-svelte-h":!0}),m(Le)!=="svelte-5czlfi"&&(Le.innerHTML=Gn),It=i(e),M=o(e,"H2",{class:!0});var Zt=d(M);Q=o(Zt,"A",{id:!0,class:!0,href:!0});var xr=d(Q);et=o(xr,"SPAN",{});var $r=d(et);f(He.$$.fragment,$r),$r.forEach(t),xr.forEach(t),cn=i(Zt),Ve=o(Zt,"SPAN",{"data-svelte-h":!0}),m(Ve)!=="svelte-11v4ufk"&&(Ve.textContent=Jn),Zt.forEach(t),Dt=i(e),Pe=o(e,"P",{"data-svelte-h":!0}),m(Pe)!=="svelte-5dg4ch"&&(Pe.innerHTML=Kn),Rt=i(e),tt=o(e,"P",{}),d(tt).forEach(t),this.h()},h(){l(c,"name","hf:doc:metadata"),l(c,"content",JSON.stringify(kr)),l(S,"id","unit-3-architectures-de-transformers-pour-laudio"),l(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(S,"href","#unit-3-architectures-de-transformers-pour-laudio"),l(_,"class","relative group"),l(A,"id","comment-fonctionne-un-transformer"),l(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(A,"href","#comment-fonctionne-un-transformer"),l(C,"class","relative group"),l(N,"class","flex justify-center"),l(j,"id","utilisation-de-transformers-pour-laudio"),l(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(j,"href","#utilisation-de-transformers-pour-laudio"),l(q,"class","relative group"),l(z,"class","flex justify-center"),l(U,"id","entres-du-modle"),l(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(U,"href","#entres-du-modle"),l(b,"class","relative group"),l(I,"id","entre-textuelle"),l(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(I,"href","#entre-textuelle"),l(T,"class","relative group"),l(D,"id","entre-sous-forme-de-forme-donde"),l(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(D,"href","#entre-sous-forme-de-forme-donde"),l(y,"class","relative group"),l(R,"class","flex justify-center"),l(V,"id","entre-sous-forme-de-spectrogramme"),l(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(V,"href","#entre-sous-forme-de-spectrogramme"),l(L,"class","relative group"),l(F,"class","flex justify-center"),l(W,"id","sorties-du-modle"),l(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(W,"href","#sorties-du-modle"),l(H,"class","relative group"),l(B,"id","sortie-textuelle"),l(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(B,"href","#sortie-textuelle"),l(P,"class","relative group"),l(O,"id","sortie-sous-forme-de-spectrogramme"),l(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(O,"href","#sortie-sous-forme-de-spectrogramme"),l(k,"class","relative group"),l(G,"class","flex justify-center"),l(K,"id","sortie-sous-forme-de-forme-donde"),l(K,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(K,"href","#sortie-sous-forme-de-forme-donde"),l(E,"class","relative group"),l(Q,"id","conclusion"),l(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Q,"href","#conclusion"),l(M,"class","relative group")},m(e,n){u(document.head,c),r(e,w,n),r(e,X,n),r(e,rt,n),r(e,_,n),u(_,S),u(S,Fe),h(Y,Fe,null),u(_,en),u(_,Ee),r(e,st,n),r(e,Z,n),r(e,ot,n),r(e,C,n),u(C,A),u(A,We),h(ee,We,null),u(C,tn),u(C,Me),r(e,lt,n),r(e,te,n),r(e,at,n),r(e,N,n),r(e,it,n),r(e,ne,n),r(e,ut,n),r(e,re,n),r(e,dt,n),r(e,q,n),u(q,j),u(j,Be),h(se,Be,null),u(q,nn),u(q,Se),r(e,mt,n),r(e,oe,n),r(e,ct,n),r(e,z,n),r(e,pt,n),r(e,le,n),r(e,ft,n),r(e,ae,n),r(e,ht,n),r(e,ie,n),r(e,vt,n),r(e,b,n),u(b,U),u(U,Oe),h(ue,Oe,null),u(b,rn),u(b,Ae),r(e,gt,n),r(e,de,n),r(e,xt,n),r(e,T,n),u(T,I),u(I,Ge),h(me,Ge,null),u(T,sn),u(T,Ne),r(e,$t,n),r(e,ce,n),r(e,wt,n),r(e,y,n),u(y,D),u(D,Je),h(pe,Je,null),u(y,on),u(y,je),r(e,_t,n),r(e,fe,n),r(e,Ct,n),r(e,R,n),r(e,qt,n),r(e,he,n),r(e,bt,n),r(e,L,n),u(L,V),u(V,Ke),h(ve,Ke,null),u(L,ln),u(L,ze),r(e,Tt,n),r(e,ge,n),r(e,yt,n),r(e,F,n),r(e,Lt,n),r(e,xe,n),r(e,Ht,n),r(e,$e,n),r(e,Pt,n),r(e,H,n),u(H,W),u(W,Qe),h(we,Qe,null),u(H,an),u(H,Ue),r(e,kt,n),r(e,_e,n),r(e,Et,n),r(e,P,n),u(P,B),u(B,Xe),h(Ce,Xe,null),u(P,un),u(P,Ie),r(e,Mt,n),r(e,qe,n),r(e,St,n),r(e,k,n),u(k,O),u(O,Ye),h(be,Ye,null),u(k,dn),u(k,De),r(e,At,n),r(e,Te,n),r(e,Nt,n),r(e,G,n),r(e,jt,n),h(J,e,n),r(e,zt,n),r(e,E,n),u(E,K),u(K,Ze),h(ye,Ze,null),u(E,mn),u(E,Re),r(e,Ut,n),r(e,Le,n),r(e,It,n),r(e,M,n),u(M,Q),u(Q,et),h(He,et,null),u(M,cn),u(M,Ve),r(e,Dt,n),r(e,Pe,n),r(e,Rt,n),r(e,tt,n),Vt=!0},p(e,[n]){const ke={};n&2&&(ke.$$scope={dirty:n,ctx:e}),J.$set(ke)},i(e){Vt||(v(Y.$$.fragment,e),v(ee.$$.fragment,e),v(se.$$.fragment,e),v(ue.$$.fragment,e),v(me.$$.fragment,e),v(pe.$$.fragment,e),v(ve.$$.fragment,e),v(we.$$.fragment,e),v(Ce.$$.fragment,e),v(be.$$.fragment,e),v(J.$$.fragment,e),v(ye.$$.fragment,e),v(He.$$.fragment,e),Vt=!0)},o(e){g(Y.$$.fragment,e),g(ee.$$.fragment,e),g(se.$$.fragment,e),g(ue.$$.fragment,e),g(me.$$.fragment,e),g(pe.$$.fragment,e),g(ve.$$.fragment,e),g(we.$$.fragment,e),g(Ce.$$.fragment,e),g(be.$$.fragment,e),g(J.$$.fragment,e),g(ye.$$.fragment,e),g(He.$$.fragment,e),Vt=!1},d(e){e&&(t(w),t(X),t(rt),t(_),t(st),t(Z),t(ot),t(C),t(lt),t(te),t(at),t(N),t(it),t(ne),t(ut),t(re),t(dt),t(q),t(mt),t(oe),t(ct),t(z),t(pt),t(le),t(ft),t(ae),t(ht),t(ie),t(vt),t(b),t(gt),t(de),t(xt),t(T),t($t),t(ce),t(wt),t(y),t(_t),t(fe),t(Ct),t(R),t(qt),t(he),t(bt),t(L),t(Tt),t(ge),t(yt),t(F),t(Lt),t(xe),t(Ht),t($e),t(Pt),t(H),t(kt),t(_e),t(Et),t(P),t(Mt),t(qe),t(St),t(k),t(At),t(Te),t(Nt),t(G),t(jt),t(zt),t(E),t(Ut),t(Le),t(It),t(M),t(Dt),t(Pe),t(Rt),t(tt)),t(c),x(Y),x(ee),x(se),x(ue),x(me),x(pe),x(ve),x(we),x(Ce),x(be),x(J,e),x(ye),x(He)}}}const kr={local:"unit-3-architectures-de-transformers-pour-laudio",sections:[{local:"comment-fonctionne-un-transformer",title:"Comment fonctionne un transformer ?"},{local:"utilisation-de-transformers-pour-laudio",title:"Utilisation de *transformers* pour l'audio"},{local:"entres-du-modle",sections:[{local:"entre-textuelle",title:"Entrée textuelle"},{local:"entre-sous-forme-de-forme-donde",title:"Entrée sous forme de forme d'onde"},{local:"entre-sous-forme-de-spectrogramme",title:"Entrée sous forme de spectrogramme"}],title:"Entrées du modèle"},{local:"sorties-du-modle",sections:[{local:"sortie-textuelle",title:"Sortie textuelle"},{local:"sortie-sous-forme-de-spectrogramme",title:"Sortie sous forme de spectrogramme"},{local:"sortie-sous-forme-de-forme-donde",title:"Sortie sous forme de forme d'onde"}],title:"Sorties du modèle"},{local:"conclusion",title:"Conclusion"}],title:"Unité 3 : Architectures de transformers pour l'audio"};function Er(nt){return _r(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class jr extends Cr{constructor(c){super(),qr(this,c,Er,Pr,wr,{})}}export{jr as component};
